﻿init python:
    class achievement_handler:
        def __init__(self):
            self.all = []
            self.pending = []
            self.log = []
        def tick(self):
            if not renpy.get_screen("achievements_announce"):
                ach = self.pending.pop(0)
                Show("achievements_announce", a = ach)()
        def add(self, item):
            self.all.append(item)
        def log_pop(self):
            self.log.pop(0)
        def got(self, ach):
            for n, i in enumerate(self.all):
                if i[0] == ach:
                    if i[1] == 0:
                        self.all[n][1] = 1
                        self.pending.append(ach)
                        self.log.append("Achievement unlocked: {}".format(i[0].name))
                    
    achieves = achievement_handler()
    class achievement:
        def __init__(self, name, info, icon = "achievement_no_icon", conditions = [], perks = []):
            self.name = name
            self.info = info
            self.icon = icon
            self.conditions = conditions
            self.perks = perks
            achieves.add([self, 0])


screen achievements(a = achieves):
    text str(len(a.all))
    vbox:
        fixed:
            fit_first True
            spacing 8
            viewport:
                id "ach_vp"
                xysize 1000,800
                draggable True
                vbox:
                    align .5,.5 spacing 4
                    for i in a.all:
                        frame:
                            xsize 1000 padding 8,8
                            hbox:
                                spacing 8 xalign .0
                                if i[1]:
                                    add i[0].icon
                                else:
                                    frame:
                                        xysize 128,128
                                vbox:
                                    if i[1]:
                                        text i[0].name xalign .0 size 30
                                    else:
                                        text _("Locked") xalign .0 size 30
                                    text i[0].info xalign .0

            vbar value YScrollValue("ach_vp") xysize 40,800 xalign .0 xoffset -48
            vbar value YScrollValue("ach_vp") xysize 40,800 xalign 1.0 xoffset 48
        button:
            text _("Return")
            action Hide("achievements")

init python:
    config.overlay_screens.append("achievements_overlay")
screen achievements_overlay(a = achieves):
    button:
        align 1.0,.0 margin 40,40
        text "Achievements"
        action Show("achievements")
    if len(a.pending):
        timer 1 repeat True action Function(a.tick)
    if len(a.log):
        timer 5 repeat True action Function(a.log_pop)
        vbox:
            align .0,.0
            for i in a.log:
                text i


screen achievements_announce(a):
    timer 4 action Hide("achievements_announce")
    frame:
        xsize 1000 padding 8,8 align .5,.0
        at achievements_announce_anim
        hbox:
            spacing 8 xalign .0
            add a.icon
            vbox:
                text a.name xalign .0 size 30
                text a.info xalign .0

transform achievements_announce_anim:
    yoffset -300 alpha 0 zoom .4
    ease .4 yoffset 60 alpha 1 zoom 1
    pause 3
    ease .4 yoffset -300 alpha 0 zoom .4



# Define your achievements, you can define them all in the same place or in any file you want
define opened_the_game = achievement(
    name = _("Opened the game"),
    info = _("Installing a game and opening it is not a trivial task, but you've done it! Yay!"),
    icon = "opened_the_game",
)
define a_new_start = achievement(
    _("A new start"),
    _("Starting a new life, with a clean slate."),
    "a_new_start",
)
define advance = achievement(
    _("Advance"),
    _("For clicking the first time to advance the game."),
    "advance_achievement",
)
define golden_opportunity = achievement(
    _("The golden opportunity"),
    _("There she is, and no trace of her annoying friend. Go talk to her."),
    "golden_opportunity",
)
define push_the_button = achievement(
    _("Push the button"),
    _("You've pushed THE button."),
)
define no_button_pushing = achievement(
    _("No button pushing"),
    _("Wow, such self control."),
)
define i_am_rich = achievement(
    _("I am rich"),
    _("Collect 1000 gold."),
)
define getting_fat = achievement(
    _("Getting fat"),
    _("More than 10 cookies."),
)



screen push_the_button_screen:
    button:
        align .8,.5
        text "Push this button"
        action Function(achieves.got, push_the_button), Jump("button_pusher"), Hide("push_the_button_screen")

label splashscreen:
    $ achieves.got(opened_the_game)
    return

default cookies = 0
default gold = 129

label achievement_examples:
    $ achieves.got(a_new_start)
    show bg with dissolve
    pause
    $ achieves.got(advance)
    "Let's meet her."
    show ayame with dissolve
    $ achieves.got(golden_opportunity)
    pause 6
    show screen push_the_button_screen
    pause
    hide screen push_the_button_screen
    $ achieves.got(no_button_pushing)
    "Oh, you're not like others right?"
label achievement_examples_1:
    menu:
        "Do you want a cookie? Or some gold?"
        "Cookie.":
            $ cookies += 1
            if cookies > 10:
                $ achieves.got(getting_fat)
            "Here you go."
        "Gold.":
            $ g = renpy.random.randint(10,200)
            $ gold += g
            if gold > 999:
                $ achieves.got(i_am_rich)
            "Alright, here's [g] gold."
        "I'll pass.":
            "Alright."
            return
    jump achievement_examples_1

label button_pusher:
    "You did it."
    return







